/*******************************************************************************
 * FoxItemCacheHistory generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxItemCacheHistory extends FoxItemCacheBase
    native;

var private transient array<HistoryMetaData> CachedHistoryItems;
var private transient array<HistoryMetaData> UpdatedHistoryItems;
var private transient array<HistoryMetaData> PendingHistoryItems;
var private transient bool bHasHistory;
var private transient bool bHasHistoryUpdates;

function Cleanup()
{
    super.Cleanup();
    CachedHistoryItems.Length = 0;
    UpdatedHistoryItems.Length = 0;
    PendingHistoryItems.Length = 0;
    bHasHistory = false;
    bHasHistoryUpdates = false;
    //return;    
}

function SetupDelegates()
{
    // End:0x86
    if(NotEqual_InterfaceInterface(StoreInterface, (none)))
    {
        StoreInterface.AddQueryHistoryCompleteDelegate(0, QueryHistoryComplete);
        StoreInterface.AddHistoryUpdatedDelegate(0, OnHistoryUpdated);
    }
    //return;    
}

function CleanupDelegates()
{
    // End:0x86
    if(NotEqual_InterfaceInterface(StoreInterface, (none)))
    {
        StoreInterface.ClearQueryHistoryCompleteDelegate(0, QueryHistoryComplete);
        StoreInterface.ClearHistoryUpdatedDelegate(0, OnHistoryUpdated);
    }
    //return;    
}

// Export UFoxItemCacheHistory::execGetCachedItems(FFrame&, void* const)
native function bool GetCachedItems(out array<HistoryMetaData> UpdatedHistory, optional out array<HistoryMetaData> CachedHistory, optional out array<string> HistoryDiff, optional bool bFilterReset);

// Export UFoxItemCacheHistory::execMergeHistoryUpdates(FFrame&, void* const)
native function MergeHistoryUpdates(optional bool bForce, const optional array<string> Keys);

// Export UFoxItemCacheHistory::execCheckAndUnlockTrophys(FFrame&, void* const)
native function CheckAndUnlockTrophys();

protected function bool RefreshCache()
{
    local UniqueNetId MyId;

    // End:0x97
    if(NotEqual_InterfaceInterface(StoreInterface, (none)) && NotEqual_InterfaceInterface(PlayerInterface, (none)))
    {
        PlayerInterface.GetUniquePlayerId(0, MyId);
        return StoreInterface.QueryHistory(MyId);
    }
    return false;
    //return ReturnValue;    
}

simulated function QueryHistoryComplete(const UniqueNetId ForId, const string HistoryData)
{
    // End:0x9A
    if(IsOwner(ForId))
    {
        class'FoxHistoryMetaData'.static.ParseFromXML(UpdatedHistoryItems, HistoryData);
        PendingHistoryItems = UpdatedHistoryItems;
        // End:0x84
        if(!bHasHistory)
        {
            MergeHistoryUpdates(true);
            bHasHistory = true;
        }
        // End:0x90
        else
        {
            bHasHistoryUpdates = true;
        }
        CheckAndUnlockTrophys();
    }
    //return;    
}

simulated function OnHistoryUpdated(const UniqueNetId ForId, const string HistoryData)
{
    local array<HistoryMetaData> Updates;
    local HistoryMetaData MetaData;
    local int Index;

    // End:0x138
    if(IsOwner(ForId))
    {
        class'FoxHistoryMetaData'.static.ParseFromXML(Updates, HistoryData);
        // End:0xE4
        foreach Updates(MetaData,)
        {
            Index = UpdatedHistoryItems.Find('Key', MetaData.Key);
            // End:0xC6
            if(Index == -1)
            {
                UpdatedHistoryItems.AddItem(MetaData);
                // End:0xE3
                continue;
            }
            UpdatedHistoryItems[Index] = MetaData;            
        }        
        PendingHistoryItems = UpdatedHistoryItems;
        // End:0x122
        if(!bHasHistory)
        {
            MergeHistoryUpdates(true);
            bHasHistory = true;
        }
        // End:0x12E
        else
        {
            bHasHistoryUpdates = true;
        }
        CheckAndUnlockTrophys();
    }
    //return;    
}

simulated function LogHistory()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x31 [Loop If]
    if(I < UpdatedHistoryItems.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}
